<?php
// request main.php
$page['header'] = LBL_REQUEST;
$page['crumbs'][] = 'find';
$page['content'] = LBL_REQUEST_CONTENT . "<br>\n";

$bad_subjects = array('admin', 'GrouperSystem', 'GrouperAll');

//$page['content'] .= "<pre>" . print_r($_POST, true) . "</pre>\n";

$group_id = $_POST['group_id'];
$control = $_POST['control'];
$subject = array_key_exists('subject', $_POST) ? stripslashes($_POST['subject']) : NULL;
$body = array_key_exists('body', $_POST) ? stripslashes($_POST['body']) : NULL;

$gr = new_grouper();
if (!$gr->isConnected()) {
  $page['errors'][] = ERROR_GROUPER_CONNECT;
  return;
}
if (!source_connect($ldap)) {
  $page['errors'][] = ERROR_SOURCE_CONNECT;
  return;
}

if ($control != LBL_REQUEST_FORM_ACTION) {
  $group = $gr->getGroup($group_id);

  if (array_key_exists('cn', $_SESSION['user'])) {
    $displayname = $_SESSION['user']['cn'][0];
  } else {
    $displayname = LBL_REQUEST_I;
  }

  if (!$subject) $subject = sprintf(LBL_REQUEST_DEFAULT_SUBJECT, $group['name']);
  if (!$body) $body = sprintf(LBL_REQUEST_DEFAULT_BODY, $displayname, $group['name']);
  $page['content'] .= "<form method='post'>\n";
  $page['content'] .= "<input type=hidden name='group_id' value='" . $group_id . "'>\n";
  $page['content'] .= LBL_REQUEST_SUBJECT . "<br>\n";
  $page['content'] .= "<input type=text name='subject' size='81' value='" . htmlspecialchars($subject, ENT_QUOTES) . "'><br><br>\n";
  $page['content'] .= LBL_REQUEST_BODY . "<br>\n";
  $page['content'] .= "<textarea name='body' cols='80' rows='10'>" . htmlspecialchars($body, ENT_QUOTES) . "</textarea><br><br>\n";
  $page['content'] .= "<input type='submit' name='control' value='" . LBL_REQUEST_FORM_ACTION . "'>\n";
  $page['content'] .= "</form>\n";

} else if ($control == LBL_REQUEST_FORM_ACTION) {

  if (!db_connect($db)) {
    $page['errors'][] = ERROR_DB_CONNECT;
    return;
  }

  // Find admins from grouper
  if (!$privs = $gr->getGroupPrivileges($group_id)) {
    $page['errors'][] = ERROR_GROUPER_COMMUNICATE;
    return;
  }

  $success = 0;

  $https = $_SERVER['HTTPS'];
  $host = $_SERVER['SERVER_NAME'];
  $url = ($https ? "https" : "http") . "://$host/teams";
  $text = $body . "\n\n" . sprintf(LBL_REQUEST_BODY_FOOTER, $url);

  foreach($privs as $admin => $rights) {
    if (in_array($admin, $bad_subjects) || !in_array("admin", $rights)) continue;

    // Profile (from subject source)
    $profile = source_profile($ldap, $admin);
    if ($profile === FALSE) continue;

    for ($i = 0; $i < $profile['mail']['count']; $i++) {
      //$page['content'] .= $profile[0]['mail'][$i] . "<br>\n";
      $address = $profile['mail'][$i];
      if (!mail($address, $subject, $text, "From: systeembericht@surfteams.nl\r\nReply-To: systeembericht@surfteams.nl")) {
	$page['errors'][] = ERROR_SEND_INVITATION;
	break;
      } else {
	$success = 1;
      }
    }
  }

  if ($success) {
    $page['content'] .= LBL_REQUEST_MAIL_SENT . "<br>\n";
    set_request($db, $group_id, $uuid);
  } else {
    $page['content'] .= LBL_REQUEST_MAIL_FAIL . "<br>\n";
  }

}




?>